﻿using System.Composition;
using System.Text.RegularExpressions;

namespace BusinessRules
{
    [Export(typeof(IValidate))]
    [ExportMetadata("Name", "Email")]
    public class ValidateEmail : IValidate
    {
        const string EMAIL_PATTERN = @"^[a-zA-Z0-9_.+-]+@[a-zA-Z0-9-]+\.[a-zA-Z0-9-.]+$";

        public string Validate(string input)
        {
            if (Regex.IsMatch(input, EMAIL_PATTERN))
            {
                return "Email is valid.";
            }
            else
            {
                return "Email is not valid.";
            }
        }
    }
}
