﻿using System.Composition;
using System.Text.RegularExpressions;

namespace BusinessRules
{
    [Export(typeof(IValidate))]
    [ExportMetadata("Name", "U.S. Phone")]
    public class ValidateUSPhone : IValidate
    {
        const string PHONE_PATTERN = @"^((\(\d{3}\) ?)|(\d{3}-))?\d{3}-\d{4}$";

        public string Validate(string input)
        {
            if (Regex.IsMatch(input, PHONE_PATTERN))
            {
                return "Phone number is valid.";
            }
            else
            {
                return "Phone number is not valid.";
            }
        }
    }
}
