﻿using System;
using System.Collections.Generic;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Navigation;
using System.Composition;
using System.Composition.Hosting;
using System.Reflection;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace VSMMefDemo
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        [ImportMany]
        public IEnumerable<Lazy<BusinessRules.IValidate, BusinessRules.ValidateMetaData>> Validators { get; private set; }
        private BusinessRules.IValidate _selectedValidator;

        public MainPage()
        {
            this.InitializeComponent();

            var configuration = new ContainerConfiguration()
                        .WithAssembly(typeof(BusinessRules.IValidate).GetTypeInfo().Assembly);

            var compositionHost = configuration.CreateContainer();
            compositionHost.SatisfyImports(this);
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            ValidationTypes.DataContext = Validators;
        }

        private void Validate_Click(object sender, RoutedEventArgs e)
        {
            if (_selectedValidator == null)
                Result.Text = "No validator was found.";
            else
                Result.Text = _selectedValidator.Validate(Input.Text);
        }

        private void ValidationTypes_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (e.AddedItems.Count > 0)
                _selectedValidator = ValidationTypes.SelectedValue as BusinessRules.IValidate;
        }
    }
}
